//+------------------------------------------------------------------+
//|                                                    CandyLite.mq4 |
//|                                                    .. |
//|                                              shestovav@gmail.com |
//+------------------------------------------------------------------+
#property copyright ".."
#property link      "shestovav@gmail.com"

#include <stdlib.mqh>

extern double Profit    = 3000;
extern double Lot       = 0.1;
extern bool BU          = true;
extern double BUenter   = 150;
extern double BUstop    = 10;


int Type,Ticket;
double OpenPrise,EnterBU,StopLossBU,SLmax,Stop,StopLevel,b1,s1,b0,s0,StopLoss,Enter;
bool CheckBU;
static bool mod;

int init(){
   Profit*=Point; 
   BUenter*=Point;
   BUstop*=Point;
   return(0);
  }

int deinit() {
   return(0);
  }

int start() {
   StopLevel=Point*MarketInfo(Symbol(),MODE_STOPLEVEL);   //   //Point*
   
   if(!WorkOrders()){
      UpTrend();
      DownTrend();
   }
      
   if(WorkOrders()){
      if ((Type<=1) && mod)                           SetStop();
      if ((BU==true)&&(Type<=1)&&(!CheckBU))          SetBU();
      if ((Type==1)||(Type==5))                       UpTrend();
      if ((Type==0)||(Type==4))                       DownTrend();
      //Comment("SL=", );
   }

   return(0);
  }
//-------    ,      
void UpTrend(){
     if((iOpen(NULL,PERIOD_H4,1) - iClose(NULL,PERIOD_H4,1) <= 0) &&
        (iOpen(NULL,PERIOD_H4,2) - iClose(NULL,PERIOD_H4,2) > 0)){
         Enter=iHigh(NULL,PERIOD_H4,1)+(Ask-Bid)+10*Point;
         SLmax=iLow(NULL,PERIOD_H4,1)-10*Point;
         if(IsTradeAllowed()){
            DellAllOrders();
            if(Enter-Ask>StopLevel-0.5*Point){
               OrderSend(Symbol(), OP_BUYSTOP, Lot, Enter, 0, SLmax, Enter+Profit, 0, 0,0, Green);
               mod=true;}
         else Sleep(1000);
         }
      }
  }
void DownTrend(){
     if((iOpen(NULL,PERIOD_H4,1) - iClose(NULL,PERIOD_H4,1) >= 0) &&
        (iOpen(NULL,PERIOD_H4,2) - iClose(NULL,PERIOD_H4,2) < 0)){
         Enter=iLow(NULL,PERIOD_H4,1)-10*Point;
         SLmax=iHigh(NULL,PERIOD_H4,1)+(Ask-Bid)+10*Point;
         if(IsTradeAllowed()){
            DellAllOrders();
            if(Bid-Enter>StopLevel-0.5*Point){
               OrderSend(Symbol(), OP_SELLSTOP, Lot, Enter, 0, SLmax, Enter-Profit, 0, 0,0, Green);
               mod=true;}
         else Sleep(1000);
         }
      }
  }

//-------   
void SetStop(){
         if(Type==0){
            b0=iLow(NULL,PERIOD_H4,0)-10*Point;
            b1=iLow(NULL,PERIOD_H4,1)-10*Point;
            StopLoss=MathMax(b0,b1);
            if(MathAbs(Stop-StopLoss)>0.5*Point//  1
            && Bid-StopLoss>StopLevel-0.5*Point)//  130
               if(OrderModify(Ticket,OpenPrise,StopLoss,OrderTakeProfit(),0,Red)) mod=false;
         }
         if(Type==1){
            s0=iHigh(NULL,PERIOD_H4,0)+(Ask-Bid)+10*Point;
            s1=iHigh(NULL,PERIOD_H4,1)+(Ask-Bid)+10*Point;
            StopLoss=MathMin(s0,s1);
            if(MathAbs(Stop-StopLoss)>0.5*Point
            && StopLoss-Ask>StopLevel-0.5*Point)
               if(OrderModify(Ticket,OpenPrise,StopLoss,OrderTakeProfit(),0,Red)) mod=false;
         }
   }

//-------   
void SetBU(){
      if(Type==0){
         EnterBU=OpenPrise+BUenter;
         StopLossBU=OpenPrise+BUstop;
         RefreshRates();
         if(Bid>=EnterBU){
            StopLoss=StopLossBU;
            OrderModify(Ticket,OpenPrise,StopLossBU,OrderTakeProfit(),0,Red);}
      }
      if(Type==1){
         EnterBU=OpenPrise-BUenter;
         StopLossBU=OpenPrise-BUstop;
         RefreshRates();
         if(Ask<=EnterBU){
            StopLoss=StopLossBU;
            OrderModify(Ticket,OpenPrise,StopLossBU,OrderTakeProfit(),0,Red);}
      }
}
   
//-------  ,   
void DellAllOrders(){
      if(WorkOrders()){
      if(Type<=1)OrderClose(Ticket,OrderLots(),OrderClosePrice(),10);
      else OrderDelete(Ticket);}
  }
  
//------- 
bool WorkOrders(){
      for (int i=OrdersTotal()-1;i>=0;i--){
      if (!OrderSelect(i,SELECT_BY_POS))  continue;
      if (OrderSymbol()!=Symbol())        continue;
      OpenPrise=OrderOpenPrice();
      Type     =OrderType();
      Ticket   =OrderTicket();
      Stop     =OrderStopLoss();
      CheckBU=false;
      if(Type==0 && Stop>OpenPrise) CheckBU=true;
      if(Type==1 && Stop<OpenPrise) CheckBU=true;      
      return(true);}
  return(false);
  }

